/*
 *  Tcpjunk - TCP protocols testing tool
 *  Contact: oferkv@gmail.com
 *
 *  Tcpjunk is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2, or (at your option) any
 *  later version.
 *
 *  Tcpjunk is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 */

#ifndef TCPJUNK_H
#define TCPJUNK_H

#include <netdb.h>

#define VER "2.8.21"
#define SOCK_BUF_LEN 16384
#define MAXLINE 1024
#define BACKLOG 10
#define MAX_SECTS 100
char log_msg[MAXLINE];

/* GUI error colors */
enum error_colors
  {
  c_black,
  c_red,
  c_red_hl,
  c_blue_hl
  };

/* modes for picking session files */
enum auto_file_mode
  {
  f_none,
  f_rand,
  f_seq
  };

/* client or server address info */
enum ai_passive
  {
  ai_none,
  ai_passive,
  };

struct tj_data
  {
	/* network data */
	struct addrinfo *remote_addr;
	struct addrinfo *local_addr;
	char port[16];
	char src_port[16];
	char *src_addr;
	int src_addr_len;
	int src_ip_num_ses;
	char src_ip[128];
	char interface[32];
	int offset;
	int srv_sock;

	/* session data */
	char *sess_data;
	int sess_data_len;
	char sess_file_name[FILENAME_MAX];
	int sess_data_modified;
	char *sects[MAX_SECTS];
	int sects_len[MAX_SECTS];
	int sect_idx;
	int auto_file;
	char **files_list;
	int auto_files_num;

	/* general data */
	int server_mode;
	int ipv6;
	int gui;
	int debug;
	int verbose;
	int hexdump;
	int wait;
	int conn_timeout;
	int reply_timeout;
	unsigned int keepalive;
	unsigned int loop;
	int wait_conn;
	int no_wait_last;
	int use_ssl;
	char server_cert[FILENAME_MAX];
	char server_key[FILENAME_MAX];
	int send_size;
	int send_delay;
	unsigned int inst_num;
  };

#endif

